/*
 * Created on 2019-08-19 ( Time 15:02:29 )
 * Generated by Telosys Tools Generator ( version 3.0.0 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.diaspora.star.motors.sarl.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;
import java.util.List;

import javax.persistence.*;

/**
 * Persistent class for entity stored in table "user"
 *
 * @author Telosys Tools Generator
 *
 */

@Entity
@Table(name="user" )
public class User implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="nom", length=255)
    private String     nom          ;

	/*
	 * 
	 */
    @Column(name="prenom", length=255)
    private String     prenom       ;

	/*
	 * 
	 */
    @Column(name="email", length=255)
    private String     email        ;

	/*
	 * 
	 */
    @Column(name="login", length=255)
    private String     login        ;

	/*
	 * 
	 */
    @Column(name="password", length=255)
    private String     password     ;

	/*
	 * 
	 */
    @Column(name="telephone", length=255)
    private String     telephone    ;

	/*
	 * 
	 */
    @Column(name="token", length=255)
    private String     token        ;

	/*
	 * 
	 */
    @Column(name="is_valid_token")
    private Boolean    isValidToken ;
    
    /*
	 * 
	 */
    @Column(name="is_super_user")
    private Boolean    isSuperUser ;


	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_expire_token")
    private Date       dateExpireToken ;

	/*
	 * 
	 */
    @Column(name="last_password", length=255)
    private String     lastPassword ;

	/*
	 * 
	 */
    @Column(name="signature_url", length=255)
    private String     signatureUrl ;

	/*
	 * 
	 */
    @Column(name="is_locked")
    private Boolean    isLocked     ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	// "roleId" (column "role_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="role_id", referencedColumnName="id")
    private Role role        ;

    //----------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //----------------------------------------------------------------------
    public User() {
		super();
    }
    
    //----------------------------------------------------------------------
    // GETTER & SETTER FOR THE KEY FIELD
    //----------------------------------------------------------------------
    public void setId( Integer id ) {
        this.id = id ;
    }
    public Integer getId() {
        return this.id;
    }

    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR FIELDS
    //----------------------------------------------------------------------
    //--- DATABASE MAPPING : nom ( VARCHAR ) 
    public void setNom( String nom ) {
        this.nom = nom;
    }
    public String getNom() {
        return this.nom;
    }

    //--- DATABASE MAPPING : prenom ( VARCHAR ) 
    public void setPrenom( String prenom ) {
        this.prenom = prenom;
    }
    public String getPrenom() {
        return this.prenom;
    }

    //--- DATABASE MAPPING : email ( VARCHAR ) 
    public void setEmail( String email ) {
        this.email = email;
    }
    public String getEmail() {
        return this.email;
    }

    //--- DATABASE MAPPING : login ( VARCHAR ) 
    public void setLogin( String login ) {
        this.login = login;
    }
    public String getLogin() {
        return this.login;
    }

    //--- DATABASE MAPPING : password ( VARCHAR ) 
    public void setPassword( String password ) {
        this.password = password;
    }
    public String getPassword() {
        return this.password;
    }

    //--- DATABASE MAPPING : telephone ( VARCHAR ) 
    public void setTelephone( String telephone ) {
        this.telephone = telephone;
    }
    public String getTelephone() {
        return this.telephone;
    }

    //--- DATABASE MAPPING : token ( VARCHAR ) 
    public void setToken( String token ) {
        this.token = token;
    }
    public String getToken() {
        return this.token;
    }

    //--- DATABASE MAPPING : is_valid_token ( BIT ) 
    public void setIsValidToken( Boolean isValidToken ) {
        this.isValidToken = isValidToken;
    }
    public Boolean getIsValidToken() {
        return this.isValidToken;
    }

    //--- DATABASE MAPPING : date_expire_token ( DATETIME ) 
    public void setDateExpireToken( Date dateExpireToken ) {
        this.dateExpireToken = dateExpireToken;
    }
    public Date getDateExpireToken() {
        return this.dateExpireToken;
    }

    //--- DATABASE MAPPING : last_password ( VARCHAR ) 
    public void setLastPassword( String lastPassword ) {
        this.lastPassword = lastPassword;
    }
    public String getLastPassword() {
        return this.lastPassword;
    }

    //--- DATABASE MAPPING : signature_url ( VARCHAR ) 
    public void setSignatureUrl( String signatureUrl ) {
        this.signatureUrl = signatureUrl;
    }
    public String getSignatureUrl() {
        return this.signatureUrl;
    }

    //--- DATABASE MAPPING : is_locked ( BIT ) 
    public void setIsLocked( Boolean isLocked ) {
        this.isLocked = isLocked;
    }
    public Boolean getIsLocked() {
        return this.isLocked;
    }

    //--- DATABASE MAPPING : is_deleted ( BIT ) 
    public void setIsDeleted( Boolean isDeleted ) {
        this.isDeleted = isDeleted;
    }
    public Boolean getIsDeleted() {
        return this.isDeleted;
    }

    //--- DATABASE MAPPING : created_at ( DATETIME ) 
    public void setCreatedAt( Date createdAt ) {
        this.createdAt = createdAt;
    }
    public Date getCreatedAt() {
        return this.createdAt;
    }

    //--- DATABASE MAPPING : updated_at ( DATETIME ) 
    public void setUpdatedAt( Date updatedAt ) {
        this.updatedAt = updatedAt;
    }
    public Date getUpdatedAt() {
        return this.updatedAt;
    }

    //--- DATABASE MAPPING : deleted_at ( DATETIME ) 
    public void setDeletedAt( Date deletedAt ) {
        this.deletedAt = deletedAt;
    }
    public Date getDeletedAt() {
        return this.deletedAt;
    }

    //--- DATABASE MAPPING : created_by ( INT ) 
    public void setCreatedBy( Integer createdBy ) {
        this.createdBy = createdBy;
    }
    public Integer getCreatedBy() {
        return this.createdBy;
    }

    //--- DATABASE MAPPING : updated_by ( INT ) 
    public void setUpdatedBy( Integer updatedBy ) {
        this.updatedBy = updatedBy;
    }
    public Integer getUpdatedBy() {
        return this.updatedBy;
    }

    //--- DATABASE MAPPING : deleted_by ( INT ) 
    public void setDeletedBy( Integer deletedBy ) {
        this.deletedBy = deletedBy;
    }
    public Integer getDeletedBy() {
        return this.deletedBy;
    }


    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR LINKS
    //----------------------------------------------------------------------

    public Boolean getIsSuperUser() {
		return isSuperUser;
	}

	public void setIsSuperUser(Boolean isSuperUser) {
		this.isSuperUser = isSuperUser;
	}

	public void setRole( Role role ) {
        this.role = role;
    }
    public Role getRole() {
        return this.role;
    }


    //----------------------------------------------------------------------
    // toString METHOD
    //----------------------------------------------------------------------
    public String toString() { 
        StringBuffer sb = new StringBuffer(); 
        sb.append("["); 
        sb.append(id);
        sb.append("]:"); 
        sb.append(nom);
        sb.append("|");
        sb.append(prenom);
        sb.append("|");
        sb.append(email);
        sb.append("|");
        sb.append(login);
        sb.append("|");
        sb.append(password);
        sb.append("|");
        sb.append(telephone);
        sb.append("|");
        sb.append(token);
        sb.append("|");
        sb.append(isValidToken);
        sb.append("|");
        sb.append(isSuperUser);
        sb.append("|");
        sb.append(dateExpireToken);
        sb.append("|");
        sb.append(lastPassword);
        sb.append("|");
        sb.append(signatureUrl);
        sb.append("|");
        sb.append(isLocked);
        sb.append("|");
        sb.append(isDeleted);
        sb.append("|");
        sb.append(createdAt);
        sb.append("|");
        sb.append(updatedAt);
        sb.append("|");
        sb.append(deletedAt);
        sb.append("|");
        sb.append(createdBy);
        sb.append("|");
        sb.append(updatedBy);
        sb.append("|");
        sb.append(deletedBy);
        return sb.toString(); 
    } 

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
